#property copyright "Andrew Opeyda [ njel ]  2010, AISignals."
#property link      "http://www.aiSignals.com"

#property indicator_chart_window
#property indicator_buffers 8
#property indicator_color1 Red
#property indicator_color2 Gray
#property indicator_color3 DeepPink
#property indicator_color4 Peru
#property indicator_color5 BlueViolet
#property indicator_color6 DeepPink
#property indicator_color7 MediumTurquoise
#property indicator_color8 Crimson

int Gcount76 = 0;
string Gsobj80 = "obj";
double Gibuf88[];
double Gibuf92[];
double Gibuf96[];
double Gibuf100[];
double Gibuf104[];
double Gibuf108[];
double Gibuf112[];
extern double Threshold = 0.8;
extern int nobs = 500;
extern int FiltPer = 8;
double Gda132[170];
double Gda136[170];
double Gda140[170];
string Gda144[170];
double Gda148[170];
string Gsbat152 = "Bat";
string Gscrab160 = "Crab";
string Gsgartley168 = "Gartley";
string Gs176 = "Butterfly";
double Gda184[10000];
int Gia188[10000];
double Gda192[10000];
double Gda196[10000];
int Gindex200 = 0;
double Gibuf204[];
double Gd208;

string Gfx.NewObjectName() {
   string lsret0 = Gsobj80 + "-" + Gcount76;
   Gcount76++;
   return (lsret0);
}

void Gfx.Clear() {
   for (int lcount0 = 0; lcount0 < Gcount76; lcount0++) ObjectDelete(Gsobj80 + "-" + lcount0);
   Gcount76 = 0;
}

void Gfx.LabelObjectCalendar(int ax0, int ay4, string atext8 = "epmty", color acolor16 = 42495, int afontsize20 = 10, int awindow24 = 0, int acorner28 = 0, string afontname32 = "Arial") {
   string lname40 = Gfx.NewObjectName();
   ObjectCreate(lname40, OBJ_LABEL, awindow24, 0, 0, 0, 0);
   ObjectSetText(lname40, atext8, afontsize20, afontname32, acolor16);
   ObjectSet(lname40, OBJPROP_CORNER, acorner28);
   ObjectSet(lname40, OBJPROP_XDISTANCE, ax0);
   ObjectSet(lname40, OBJPROP_YDISTANCE, ay4);
}

void Gfx.LabelObject(int ax0, int ay4, string atext8 = "epmty", color acolor16 = 42495, int afontsize20 = 10, int awindow24 = 0, int acorner28 = 0, bool ai32 = TRUE) {
   int li36 = -1;
   if (acorner28 == 3) li36 = 1;
   string lname40 = Gfx.NewObjectName();
   if (ai32) {
      ObjectCreate(lname40, OBJ_LABEL, awindow24, 0, 0, 0, 0);
      ObjectSetText(lname40, atext8, afontsize20, "Arial Black", Black);
      ObjectSet(lname40, OBJPROP_CORNER, acorner28);
      ObjectSet(lname40, OBJPROP_XDISTANCE, ax0);
      ObjectSet(lname40, OBJPROP_YDISTANCE, ay4);
      lname40 = Gfx.NewObjectName();
   }
   ObjectCreate(lname40, OBJ_LABEL, awindow24, 0, 0, 0, 0);
   ObjectSetText(lname40, atext8, afontsize20, "Arial Black", acolor16);
   ObjectSet(lname40, OBJPROP_CORNER, acorner28);
   ObjectSet(lname40, OBJPROP_XDISTANCE, ax0 + li36);
   ObjectSet(lname40, OBJPROP_YDISTANCE, ay4 + li36);
}

void Gfx.TextObject(int adatetime0, double aprice4, string atext12 = "epmty", color acolor20 = 42495, int afontsize24 = 10, int aangle28 = 0, int awindow32 = 0) {
   string lname36 = Gfx.NewObjectName();
   ObjectCreate(lname36, OBJ_TEXT, awindow32, adatetime0, aprice4, 0, 0);
   ObjectSetText(lname36, atext12, afontsize24, "Arial", acolor20);
   ObjectSet(lname36, OBJPROP_ANGLE, aangle28);
}

void Gfx.ChartObjectLine(int adatetime0, int adatetime4, double aprice8, double aprice16, color acolor24 = 42495, int awidth28 = 3, int awindow32 = 0) {
   string lname36 = Gfx.NewObjectName();
   ObjectCreate(lname36, OBJ_TREND, awindow32, adatetime0, aprice8, adatetime4, aprice16);
   ObjectSet(lname36, OBJPROP_WIDTH, awidth28);
   ObjectSet(lname36, OBJPROP_RAY, FALSE);
   ObjectSet(lname36, OBJPROP_COLOR, acolor24);
}

int deinit() {
   Gfx.Clear();
   Print("deinit =)");
   return (0);
}

int init() {
   Gfx.Clear();
   Gd208 = 0.0625 / MathPow(MathSin(3.1415926536 / FiltPer), 4);
   SetIndexBuffer(0, Gibuf204);
   SetIndexStyle(0, DRAW_NONE, STYLE_DOT);
   int li0 = 167;
   SetIndexStyle(1, DRAW_NONE, STYLE_SOLID, 1);
   SetIndexBuffer(1, Gibuf88);
   SetIndexStyle(2, DRAW_NONE, STYLE_SOLID, 2);
   SetIndexBuffer(2, Gibuf92);
   SetIndexStyle(3, DRAW_ARROW);
   SetIndexBuffer(3, Gibuf96);
   SetIndexArrow(3, li0);
   SetIndexStyle(4, DRAW_ARROW);
   SetIndexBuffer(4, Gibuf100);
   SetIndexArrow(4, li0);
   SetIndexStyle(5, DRAW_ARROW);
   SetIndexBuffer(5, Gibuf104);
   SetIndexArrow(5, li0);
   SetIndexStyle(6, DRAW_LINE);
   SetIndexBuffer(6, Gibuf108);
   SetIndexStyle(7, DRAW_LINE);
   SetIndexBuffer(7, Gibuf112);
   InitValues();
   return (0);
}

int start() {
   double lda0[];
   string ls28;
   int li36;
   double ld40;
   double ld48;
   double ld56;
   int li64;
   double listddev68;
   double ld76;
   int li84;
   double ld96;
   double ld104;
   double ld112;
   double ld120;
   string ls128;
   ArrayResize(lda0, nobs);
   for (int lindex4 = 0; lindex4 < nobs; lindex4++) lda0[lindex4] = Price(lindex4);
   HPF(nobs, Gd208, lda0, Gibuf204);
   ZZ();
   for (lindex4 = 0; lindex4 < 170; lindex4++) Gda192[lindex4] = (Gda184[lindex4] - (Gda184[lindex4 + 1])) / Point;
   string ls8 = "";
   double ldunused16 = 0;
   ArrayInitialize(Gibuf88, EMPTY_VALUE);
   ArrayInitialize(Gibuf92, EMPTY_VALUE);
   Gfx.Clear();
   bool li24 = TRUE;
   for (lindex4 = 0; lindex4 < 50; lindex4++) {
      if (Gda192[lindex4 + 0] != 0.0) {
         if (Gda192[lindex4 + 1] != 0.0) {
            if (Gda192[lindex4 + 2] != 0.0) {
               if (Gda192[lindex4 + 3] != 0.0) {
                  ls28 = "NA";
                  li36 = 15570276;
                  if (Gda192[lindex4 + 0] > 0.0) {
                     ls28 = "Bearish";
                     li36 = 255;
                  }
                  if (Gda192[lindex4 + 0] < 0.0) ls28 = "Bullish";
                  ld40 = -(Gda192[lindex4 + 2]) / (Gda192[lindex4 + 3]);
                  ld48 = -(Gda192[lindex4 + 1]) / (Gda192[lindex4 + 2]);
                  ld56 = -(Gda192[lindex4 + 0]) / (Gda192[lindex4 + 1]);
                  ls8 = ls8 + "|   " + DoubleToStr(ld40, 3) + "    |    " + DoubleToStr(ld48, 3) + "   |    " + DoubleToStr(ld56, 3) + "    |    ";
                  li64 = Check(ld40, ld48, ld56);
                  if (Gda148[li64] <= Threshold) {
                     ls8 = ls8 + Gda144[li64] + " " + ls28 + "  #" + li64;
                     Gibuf92[Gia188[lindex4 + 0]] = Gda184[lindex4 + 0];
                     Gibuf92[Gia188[lindex4 + 1]] = Gda184[lindex4 + 1];
                     Gibuf92[Gia188[lindex4 + 2]] = Gda184[lindex4 + 2];
                     Gibuf92[Gia188[lindex4 + 3]] = Gda184[lindex4 + 3];
                     Gibuf92[Gia188[lindex4 + 4]] = Gda184[lindex4 + 4];
                     listddev68 = iStdDev(NULL, 0, 10, 0, MODE_EMA, PRICE_CLOSE, Gia188[lindex4 + 0]);
                     if (Gda192[lindex4 + 0] > 0.0) {
                        Gfx.TextObject(Time[Gia188[lindex4 + 0]], Gda184[lindex4 + 0] + 2.0 * listddev68, "D", Black, 10, 0, 0);
                        Gfx.TextObject(Time[Gia188[lindex4 + 1]], Gda184[lindex4 + 1] - 0.0 * listddev68, "C", Black, 10, 0, 0);
                        Gfx.TextObject(Time[Gia188[lindex4 + 2]], Gda184[lindex4 + 2] + 2.0 * listddev68, "B", Black, 10, 0, 0);
                        Gfx.TextObject(Time[Gia188[lindex4 + 3]], Gda184[lindex4 + 3] - 0.0 * listddev68, "A", Black, 10, 0, 0);
                        Gfx.TextObject(Time[Gia188[lindex4 + 4]], Gda184[lindex4 + 4] + 2.0 * listddev68, "X", Black, 10, 0, 0);
                     } else {
                        Gfx.TextObject(Time[Gia188[lindex4 + 0]], Gda184[lindex4 + 0] - 0.0 * listddev68, "D", Black, 10, 0, 0);
                        Gfx.TextObject(Time[Gia188[lindex4 + 1]], Gda184[lindex4 + 1] + 2.0 * listddev68, "C", Black, 10, 0, 0);
                        Gfx.TextObject(Time[Gia188[lindex4 + 2]], Gda184[lindex4 + 2] - 0.0 * listddev68, "B", Black, 10, 0, 0);
                        Gfx.TextObject(Time[Gia188[lindex4 + 3]], Gda184[lindex4 + 3] + 2.0 * listddev68, "A", Black, 10, 0, 0);
                        Gfx.TextObject(Time[Gia188[lindex4 + 4]], Gda184[lindex4 + 4] - 0.0 * listddev68, "X", Black, 10, 0, 0);
                     }
                     Gfx.ChartObjectLine(Time[Gia188[lindex4 + 0]], Time[Gia188[lindex4 + 1]], Gda184[lindex4 + 0], Gda184[lindex4 + 1], li36, 3);
                     Gfx.ChartObjectLine(Time[Gia188[lindex4 + 1]], Time[Gia188[lindex4 + 2]], Gda184[lindex4 + 1], Gda184[lindex4 + 2], li36, 3);
                     Gfx.ChartObjectLine(Time[Gia188[lindex4 + 2]], Time[Gia188[lindex4 + 3]], Gda184[lindex4 + 2], Gda184[lindex4 + 3], li36, 3);
                     Gfx.ChartObjectLine(Time[Gia188[lindex4 + 3]], Time[Gia188[lindex4 + 4]], Gda184[lindex4 + 3], Gda184[lindex4 + 4], li36, 3);
                     if (li24 == TRUE) {
                        ld76 = 1 - MathMin(1.0 * Gda148[li64], 1);
                        li24 = FALSE;
                        Gfx.LabelObject(10, 20, TimeToStr(Time[Gia188[lindex4]]), Orange, 10, 0, 0, 0);
                        Gfx.LabelObject(10, 40, Gda144[li64] + " " + ls28, li36, 10, 0, 0, 0);
                        li84 = 255;
                        for (int lcount88 = 0; lcount88 < 5; lcount88++) {
                           switch (lcount88) {
                           case 0:
                              li84 = 55295;
                              break;
                           case 1:
                              li84 = 42495;
                              break;
                           case 2:
                              li84 = 36095;
                              break;
                           case 3:
                              li84 = 17919;
                              break;
                           case 4:
                              li84 = 255;
                           }
                           if (lcount88 > 10.0 * ld76) li84 = 8421504;
                           Gfx.LabelObjectCalendar(20 * lcount88 + 10, 55, CharToStr(171), li84, 20, 0, 0, "Wingdings");
                        }
                        ld96 = Gda184[lindex4 + 1];
                        ld104 = Gda184[lindex4];
                        ld112 = ld96 - ld104;
                        ld120 = Gda184[lindex4] + 0.236 * ld112;
                        ls128 = "Buy";
                        if (Gda192[lindex4 + 0] > 0.0) {
                           ld104 = Gda184[lindex4];
                           ld96 = Gda184[lindex4 + 1];
                           ld112 = ld104 - ld96;
                           ld120 = Gda184[lindex4] - 0.236 * ld112;
                           ls128 = "Sell";
                        }
                        for (int lcount136 = 0; lcount136 < 10; lcount136++) {
                           Gibuf96[Gia188[lindex4] - lcount136] = ld104;
                           Gibuf100[Gia188[lindex4] - lcount136] = ld96;
                           Gibuf104[Gia188[lindex4] - lcount136] = ld120;
                        }
                        Gfx.LabelObject(10, 80, ls128, li36, 10, 0, 0, 0);
                        Gfx.LabelObject(10, 95, "Target", Orange, 10, 0, 0, 0);
                        Gfx.LabelObject(10, 110, "StopLoss", Orange, 10, 0, 0, 0);
                        Gfx.LabelObject(100, 80, "" + DoubleToStr(ld120, Digits), li36, 10, 0, 0, 0);
                        Gfx.LabelObject(100, 95, "" + DoubleToStr(ld96, Digits), Orange, 10, 0, 0, 0);
                        Gfx.LabelObject(100, 110, "" + DoubleToStr(ld104, Digits), Orange, 10, 0, 0, 0);
                        GlobalVariableSet("ENTRY", ld120);
                        GlobalVariableSet("TP", ld96);
                        GlobalVariableSet("SL", ld104);
                        GlobalVariableSet("Time", Time[Gia188[lindex4]]);
                     }
                  }
               }
            }
         }
      }
   }
   return (0);
}

void ZZ() {
   int li4;
   Gindex200 = 0;
   ArrayInitialize(Gibuf88, EMPTY_VALUE);
   Gibuf88[0] = Close[0];
   for (int lindex0 = 0; lindex0 < nobs; lindex0++) {
      if (Gibuf204[lindex0] >= Gibuf204[lindex0 - 1] && Gibuf204[lindex0] >= Gibuf204[lindex0 + 1]) {
         li4 = ArrayMaximum(High, 4, lindex0 - 1);
         Gibuf88[lindex0] = High[li4];
         Gda184[Gindex200] = Gibuf88[lindex0];
         Gia188[Gindex200] = lindex0;
         Gindex200++;
      }
      if (Gibuf204[lindex0] <= Gibuf204[lindex0 - 1] && Gibuf204[lindex0] <= Gibuf204[lindex0 + 1]) {
         li4 = ArrayMinimum(Low, 4, lindex0 - 1);
         Gibuf88[lindex0] = Low[li4];
         Gda184[Gindex200] = Gibuf88[lindex0];
         Gia188[Gindex200] = lindex0;
         Gindex200++;
      }
   }
}

void HPF(int ai0, double ad4, double ada12[], double &ada16[]) {
   double lda20[];
   double lda24[];
   double lda28[];
   double ld32;
   double ld40;
   double ld48;
   double ld56;
   double ld64;
   double ld72;
   double ld80;
   double ld88;
   double ld104;
   double ld112;
   double ld120;
   double ld128;
   ArrayResize(lda20, ai0);
   ArrayResize(lda24, ai0);
   ArrayResize(lda28, ai0);
   lda20[0] = ad4 + 1.0;
   lda24[0] = -2.0 * ad4;
   lda28[0] = ad4;
   for (int lindex136 = 1; lindex136 < ai0 - 2; lindex136++) {
      lda20[lindex136] = 6.0 * ad4 + 1.0;
      lda24[lindex136] = -4.0 * ad4;
      lda28[lindex136] = ad4;
   }
   lda20[1] = 5.0 * ad4 + 1.0;
   lda20[ai0 - 1] = ad4 + 1.0;
   lda20[ai0 - 2] = 5.0 * ad4 + 1.0;
   lda24[ai0 - 2] = -2.0 * ad4;
   lda24[ai0 - 1] = 0.0;
   lda28[ai0 - 2] = 0.0;
   lda28[ai0 - 1] = 0.0;
   for (lindex136 = 0; lindex136 < ai0; lindex136++) {
      ld128 = lda20[lindex136] - ld56 * ld32 - ld104 * ld80;
      ld112 = lda24[lindex136];
      ld72 = ld32;
      ld32 = (ld112 - ld56 * ld40) / ld128;
      lda24[lindex136] = ld32;
      ld120 = lda28[lindex136];
      ld80 = ld40;
      ld40 = ld120 / ld128;
      lda28[lindex136] = ld40;
      lda20[lindex136] = (ada12[lindex136] - ld88 * ld104 - ld48 * ld56) / ld128;
      ld88 = ld48;
      ld48 = lda20[lindex136];
      ld56 = ld112 - ld64 * ld72;
      ld104 = ld64;
      ld64 = ld120;
   }
   ld40 = 0;
   ld32 = lda20[ai0 - 1];
   ada16[ai0 - 1] = ld32;
   for (lindex136 = ai0 - 2; lindex136 >= 0; lindex136--) {
      ada16[lindex136] = lda20[lindex136] - lda24[lindex136] * ld32 - lda28[lindex136] * ld40;
      ld40 = ld32;
      ld32 = ada16[lindex136];
   }
}

double Price(int ai0) {
   double ldret4 = (High[ai0] + Low[ai0]) / 2.0;
   return (ldret4);
}

void InitValues() {
   Gda132[0] = 0.382;
   Gda136[0] = 0.382;
   Gda140[0] = 2.618;
   Gda144[0] = Gsbat152;
   Gda132[1] = 0.382;
   Gda136[1] = 0.447;
   Gda140[1] = 2.618;
   Gda144[1] = Gsbat152;
   Gda132[2] = 0.382;
   Gda136[2] = 0.5;
   Gda140[2] = 2.618;
   Gda144[2] = Gsbat152;
   Gda132[3] = 0.382;
   Gda136[3] = 0.618;
   Gda140[3] = 2.618;
   Gda144[3] = Gsbat152;
   Gda132[4] = 0.382;
   Gda136[4] = 0.707;
   Gda140[4] = 2.24;
   Gda144[4] = Gsbat152;
   Gda132[5] = 0.382;
   Gda136[5] = 0.707;
   Gda140[5] = 2.618;
   Gda144[5] = Gsbat152;
   Gda132[6] = 0.382;
   Gda136[6] = 0.786;
   Gda140[6] = 2.24;
   Gda144[6] = Gsbat152;
   Gda132[7] = 0.382;
   Gda136[7] = 0.786;
   Gda140[7] = 2.618;
   Gda144[7] = Gsbat152;
   Gda132[8] = 0.382;
   Gda136[8] = 0.886;
   Gda140[8] = 2.0;
   Gda144[8] = Gsbat152;
   Gda132[9] = 0.382;
   Gda136[9] = 0.886;
   Gda140[9] = 2.24;
   Gda144[9] = Gsbat152;
   Gda132[10] = 0.382;
   Gda136[10] = 0.886;
   Gda140[10] = 2.618;
   Gda144[10] = Gsbat152;
   Gda132[11] = 0.5;
   Gda136[11] = 0.382;
   Gda140[11] = 2.24;
   Gda144[11] = Gsbat152;
   Gda132[12] = 0.5;
   Gda136[12] = 0.382;
   Gda140[12] = 2.618;
   Gda144[12] = Gsbat152;
   Gda132[13] = 0.5;
   Gda136[13] = 0.447;
   Gda140[13] = 2.24;
   Gda144[13] = Gsbat152;
   Gda132[14] = 0.5;
   Gda136[14] = 0.447;
   Gda140[14] = 2.618;
   Gda144[14] = Gsbat152;
   Gda132[15] = 0.5;
   Gda136[15] = 0.5;
   Gda140[15] = 2.0;
   Gda144[15] = Gsbat152;
   Gda132[16] = 0.5;
   Gda136[16] = 0.5;
   Gda140[16] = 2.24;
   Gda144[16] = Gsbat152;
   Gda132[17] = 0.5;
   Gda136[17] = 0.5;
   Gda140[17] = 2.618;
   Gda144[17] = Gsbat152;
   Gda132[18] = 0.5;
   Gda136[18] = 0.618;
   Gda140[18] = 1.618;
   Gda144[18] = Gsbat152;
   Gda132[19] = 0.5;
   Gda136[19] = 0.618;
   Gda140[19] = 2.0;
   Gda144[19] = Gsbat152;
   Gda132[20] = 0.5;
   Gda136[20] = 0.618;
   Gda140[20] = 2.24;
   Gda144[20] = Gsbat152;
   Gda132[21] = 0.5;
   Gda136[21] = 0.618;
   Gda140[21] = 2.618;
   Gda144[21] = Gsbat152;
   Gda132[22] = 0.5;
   Gda136[22] = 0.707;
   Gda140[22] = 1.618;
   Gda144[22] = Gsbat152;
   Gda132[23] = 0.5;
   Gda136[23] = 0.707;
   Gda140[23] = 2.0;
   Gda144[23] = Gsbat152;
   Gda132[24] = 0.5;
   Gda136[24] = 0.707;
   Gda140[24] = 2.24;
   Gda144[24] = Gsbat152;
   Gda132[25] = 0.5;
   Gda136[25] = 0.707;
   Gda140[25] = 2.618;
   Gda144[25] = Gsbat152;
   Gda132[26] = 0.5;
   Gda136[26] = 0.786;
   Gda140[26] = 1.618;
   Gda144[26] = Gsbat152;
   Gda132[27] = 0.5;
   Gda136[27] = 0.786;
   Gda140[27] = 2.0;
   Gda144[27] = Gsbat152;
   Gda132[28] = 0.5;
   Gda136[28] = 0.786;
   Gda140[28] = 2.24;
   Gda144[28] = Gsbat152;
   Gda132[29] = 0.5;
   Gda136[29] = 0.786;
   Gda140[29] = 2.618;
   Gda144[29] = Gsbat152;
   Gda132[30] = 0.5;
   Gda136[30] = 0.886;
   Gda140[30] = 1.618;
   Gda144[30] = Gsbat152;
   Gda132[31] = 0.5;
   Gda136[31] = 0.886;
   Gda140[31] = 2.0;
   Gda144[31] = Gsbat152;
   Gda132[32] = 0.5;
   Gda136[32] = 0.886;
   Gda140[32] = 2.24;
   Gda144[32] = Gsbat152;
   Gda132[33] = 0.5;
   Gda136[33] = 0.886;
   Gda140[33] = 2.618;
   Gda144[33] = Gsbat152;
   Gda132[34] = 0.382;
   Gda136[34] = 0.382;
   Gda140[34] = 1.618;
   Gda144[34] = Gscrab160;
   Gda132[35] = 0.382;
   Gda136[35] = 0.382;
   Gda140[35] = 2.0;
   Gda144[35] = Gscrab160;
   Gda132[36] = 0.382;
   Gda136[36] = 0.382;
   Gda140[36] = 2.24;
   Gda144[36] = Gscrab160;
   Gda132[37] = 0.382;
   Gda136[37] = 0.382;
   Gda140[37] = 2.618;
   Gda144[37] = Gscrab160;
   Gda132[38] = 0.382;
   Gda136[38] = 0.382;
   Gda140[38] = 3.14;
   Gda144[38] = Gscrab160;
   Gda132[39] = 0.382;
   Gda136[39] = 0.382;
   Gda140[39] = 3.618;
   Gda144[39] = Gscrab160;
   Gda132[40] = 0.382;
   Gda136[40] = 0.447;
   Gda140[40] = 1.618;
   Gda144[40] = Gscrab160;
   Gda132[41] = 0.382;
   Gda136[41] = 0.447;
   Gda140[41] = 2.0;
   Gda144[41] = Gscrab160;
   Gda132[42] = 0.382;
   Gda136[42] = 0.447;
   Gda140[42] = 2.24;
   Gda144[42] = Gscrab160;
   Gda132[43] = 0.382;
   Gda136[43] = 0.447;
   Gda140[43] = 2.618;
   Gda144[43] = Gscrab160;
   Gda132[44] = 0.382;
   Gda136[44] = 0.447;
   Gda140[44] = 3.14;
   Gda144[44] = Gscrab160;
   Gda132[45] = 0.382;
   Gda136[45] = 0.447;
   Gda140[45] = 3.618;
   Gda144[45] = Gscrab160;
   Gda132[46] = 0.382;
   Gda136[46] = 0.5;
   Gda140[46] = 1.618;
   Gda144[46] = Gscrab160;
   Gda132[47] = 0.382;
   Gda136[47] = 0.5;
   Gda140[47] = 2.0;
   Gda144[47] = Gscrab160;
   Gda132[48] = 0.382;
   Gda136[48] = 0.5;
   Gda140[48] = 2.24;
   Gda144[48] = Gscrab160;
   Gda132[49] = 0.382;
   Gda136[49] = 0.5;
   Gda140[49] = 2.618;
   Gda144[49] = Gscrab160;
   Gda132[50] = 0.382;
   Gda136[50] = 0.5;
   Gda140[50] = 3.14;
   Gda144[50] = Gscrab160;
   Gda132[51] = 0.382;
   Gda136[51] = 0.5;
   Gda140[51] = 3.618;
   Gda144[51] = Gscrab160;
   Gda132[52] = 0.382;
   Gda136[52] = 0.618;
   Gda140[52] = 1.618;
   Gda144[52] = Gscrab160;
   Gda132[53] = 0.382;
   Gda136[53] = 0.618;
   Gda140[53] = 2.0;
   Gda144[53] = Gscrab160;
   Gda132[54] = 0.382;
   Gda136[54] = 0.618;
   Gda140[54] = 2.24;
   Gda144[54] = Gscrab160;
   Gda132[55] = 0.382;
   Gda136[55] = 0.618;
   Gda140[55] = 2.618;
   Gda144[55] = Gscrab160;
   Gda132[56] = 0.382;
   Gda136[56] = 0.618;
   Gda140[56] = 3.14;
   Gda144[56] = Gscrab160;
   Gda132[57] = 0.382;
   Gda136[57] = 0.618;
   Gda140[57] = 3.618;
   Gda144[57] = Gscrab160;
   Gda132[58] = 0.382;
   Gda136[58] = 0.707;
   Gda140[58] = 1.618;
   Gda144[58] = Gscrab160;
   Gda132[59] = 0.382;
   Gda136[59] = 0.707;
   Gda140[59] = 2.0;
   Gda144[59] = Gscrab160;
   Gda132[60] = 0.382;
   Gda136[60] = 0.707;
   Gda140[60] = 2.24;
   Gda144[60] = Gscrab160;
   Gda132[61] = 0.382;
   Gda136[61] = 0.707;
   Gda140[61] = 2.618;
   Gda144[61] = Gscrab160;
   Gda132[62] = 0.382;
   Gda136[62] = 0.707;
   Gda140[62] = 3.14;
   Gda144[62] = Gscrab160;
   Gda132[63] = 0.382;
   Gda136[63] = 0.707;
   Gda140[63] = 3.618;
   Gda144[63] = Gscrab160;
   Gda132[64] = 0.382;
   Gda136[64] = 0.786;
   Gda140[64] = 1.618;
   Gda144[64] = Gscrab160;
   Gda132[65] = 0.382;
   Gda136[65] = 0.786;
   Gda140[65] = 2.0;
   Gda144[65] = Gscrab160;
   Gda132[66] = 0.382;
   Gda136[66] = 0.786;
   Gda140[66] = 2.24;
   Gda144[66] = Gscrab160;
   Gda132[67] = 0.382;
   Gda136[67] = 0.786;
   Gda140[67] = 2.618;
   Gda144[67] = Gscrab160;
   Gda132[68] = 0.382;
   Gda136[68] = 0.786;
   Gda140[68] = 3.14;
   Gda144[68] = Gscrab160;
   Gda132[69] = 0.382;
   Gda136[69] = 0.786;
   Gda140[69] = 3.618;
   Gda144[69] = Gscrab160;
   Gda132[70] = 0.382;
   Gda136[70] = 0.886;
   Gda140[70] = 1.618;
   Gda144[70] = Gscrab160;
   Gda132[71] = 0.382;
   Gda136[71] = 0.886;
   Gda140[71] = 2.0;
   Gda144[71] = Gscrab160;
   Gda132[72] = 0.382;
   Gda136[72] = 0.886;
   Gda140[72] = 2.24;
   Gda144[72] = Gscrab160;
   Gda132[73] = 0.382;
   Gda136[73] = 0.886;
   Gda140[73] = 2.618;
   Gda144[73] = Gscrab160;
   Gda132[74] = 0.382;
   Gda136[74] = 0.886;
   Gda140[74] = 3.14;
   Gda144[74] = Gscrab160;
   Gda132[75] = 0.382;
   Gda136[75] = 0.886;
   Gda140[75] = 3.618;
   Gda144[75] = Gscrab160;
   Gda132[76] = 0.447;
   Gda136[76] = 0.382;
   Gda140[76] = 1.618;
   Gda144[76] = Gscrab160;
   Gda132[77] = 0.447;
   Gda136[77] = 0.382;
   Gda140[77] = 2.0;
   Gda144[77] = Gscrab160;
   Gda132[78] = 0.447;
   Gda136[78] = 0.382;
   Gda140[78] = 2.24;
   Gda144[78] = Gscrab160;
   Gda132[79] = 0.447;
   Gda136[79] = 0.382;
   Gda140[79] = 2.618;
   Gda144[79] = Gscrab160;
   Gda132[80] = 0.447;
   Gda136[80] = 0.382;
   Gda140[80] = 3.14;
   Gda144[80] = Gscrab160;
   Gda132[81] = 0.447;
   Gda136[81] = 0.382;
   Gda140[81] = 3.618;
   Gda144[81] = Gscrab160;
   Gda132[82] = 0.447;
   Gda136[82] = 0.447;
   Gda140[82] = 1.618;
   Gda144[82] = Gscrab160;
   Gda132[83] = 0.447;
   Gda136[83] = 0.447;
   Gda140[83] = 2.0;
   Gda144[83] = Gscrab160;
   Gda132[84] = 0.447;
   Gda136[84] = 0.447;
   Gda140[84] = 2.24;
   Gda144[84] = Gscrab160;
   Gda132[85] = 0.447;
   Gda136[85] = 0.707;
   Gda140[85] = 2.24;
   Gda144[85] = Gscrab160;
   Gda132[86] = 0.5;
   Gda136[86] = 0.382;
   Gda140[86] = 3.618;
   Gda144[86] = Gscrab160;
   Gda132[87] = 0.5;
   Gda136[87] = 0.447;
   Gda140[87] = 3.618;
   Gda144[87] = Gscrab160;
   Gda132[88] = 0.5;
   Gda136[88] = 0.5;
   Gda140[88] = 3.618;
   Gda144[88] = Gscrab160;
   Gda132[89] = 0.5;
   Gda136[89] = 0.618;
   Gda140[89] = 3.618;
   Gda144[89] = Gscrab160;
   Gda132[90] = 0.5;
   Gda136[90] = 0.707;
   Gda140[90] = 3.618;
   Gda144[90] = Gscrab160;
   Gda132[91] = 0.5;
   Gda136[91] = 0.786;
   Gda140[91] = 3.14;
   Gda144[91] = Gscrab160;
   Gda132[92] = 0.5;
   Gda136[92] = 0.786;
   Gda140[92] = 3.618;
   Gda144[92] = Gscrab160;
   Gda132[93] = 0.5;
   Gda136[93] = 0.886;
   Gda140[93] = 3.14;
   Gda144[93] = Gscrab160;
   Gda132[94] = 0.5;
   Gda136[94] = 0.886;
   Gda140[94] = 3.618;
   Gda144[94] = Gscrab160;
   Gda132[95] = 0.618;
   Gda136[95] = 0.382;
   Gda140[95] = 3.618;
   Gda144[95] = Gscrab160;
   Gda132[96] = 0.618;
   Gda136[96] = 0.447;
   Gda140[96] = 3.618;
   Gda144[96] = Gscrab160;
   Gda132[97] = 0.618;
   Gda136[97] = 0.5;
   Gda140[97] = 3.14;
   Gda144[97] = Gscrab160;
   Gda132[98] = 0.618;
   Gda136[98] = 0.5;
   Gda140[98] = 3.618;
   Gda144[98] = Gscrab160;
   Gda132[99] = 0.618;
   Gda136[99] = 0.618;
   Gda140[99] = 3.14;
   Gda144[99] = Gscrab160;
   Gda132[100] = 0.618;
   Gda136[100] = 0.618;
   Gda140[100] = 3.618;
   Gda144[100] = Gscrab160;
   Gda132[101] = 0.618;
   Gda136[101] = 0.707;
   Gda140[101] = 2.618;
   Gda144[101] = Gscrab160;
   Gda132[102] = 0.618;
   Gda136[102] = 0.707;
   Gda140[102] = 3.14;
   Gda144[102] = Gscrab160;
   Gda132[103] = 0.618;
   Gda136[103] = 0.707;
   Gda140[103] = 3.618;
   Gda144[103] = Gscrab160;
   Gda132[104] = 0.618;
   Gda136[104] = 0.786;
   Gda140[104] = 2.618;
   Gda144[104] = Gscrab160;
   Gda132[105] = 0.618;
   Gda136[105] = 0.786;
   Gda140[105] = 3.14;
   Gda144[105] = Gscrab160;
   Gda132[106] = 0.618;
   Gda136[106] = 0.786;
   Gda140[106] = 3.618;
   Gda144[106] = Gscrab160;
   Gda132[107] = 0.618;
   Gda136[107] = 0.886;
   Gda140[107] = 2.24;
   Gda144[107] = Gscrab160;
   Gda132[108] = 0.618;
   Gda136[108] = 0.886;
   Gda140[108] = 2.618;
   Gda144[108] = Gscrab160;
   Gda132[109] = 0.618;
   Gda136[109] = 0.886;
   Gda140[109] = 3.14;
   Gda144[109] = Gscrab160;
   Gda132[110] = 0.886;
   Gda136[110] = 0.382;
   Gda140[110] = 2.618;
   Gda144[110] = Gscrab160;
   Gda132[111] = 0.886;
   Gda136[111] = 0.382;
   Gda140[111] = 3.14;
   Gda144[111] = Gscrab160;
   Gda132[112] = 0.886;
   Gda136[112] = 0.382;
   Gda140[112] = 3.618;
   Gda144[112] = Gscrab160;
   Gda132[113] = 0.886;
   Gda136[113] = 0.447;
   Gda140[113] = 2.24;
   Gda144[113] = Gscrab160;
   Gda132[114] = 0.886;
   Gda136[114] = 0.447;
   Gda140[114] = 2.618;
   Gda144[114] = Gscrab160;
   Gda132[115] = 0.886;
   Gda136[115] = 0.447;
   Gda140[115] = 3.14;
   Gda144[115] = Gscrab160;
   Gda132[116] = 0.886;
   Gda136[116] = 0.5;
   Gda140[116] = 2.24;
   Gda144[116] = Gscrab160;
   Gda132[117] = 0.886;
   Gda136[117] = 0.5;
   Gda140[117] = 2.618;
   Gda144[117] = Gscrab160;
   Gda132[118] = 0.886;
   Gda136[118] = 0.618;
   Gda140[118] = 2.0;
   Gda144[118] = Gscrab160;
   Gda132[119] = 0.886;
   Gda136[119] = 0.618;
   Gda140[119] = 2.24;
   Gda144[119] = Gscrab160;
   Gda132[120] = 0.886;
   Gda136[120] = 0.618;
   Gda140[120] = 2.618;
   Gda144[120] = Gscrab160;
   Gda132[121] = 0.886;
   Gda136[121] = 0.707;
   Gda140[121] = 2.0;
   Gda144[121] = Gscrab160;
   Gda132[122] = 0.886;
   Gda136[122] = 0.707;
   Gda140[122] = 2.24;
   Gda144[122] = Gscrab160;
   Gda132[123] = 0.886;
   Gda136[123] = 0.786;
   Gda140[123] = 1.618;
   Gda144[123] = Gscrab160;
   Gda132[124] = 0.886;
   Gda136[124] = 0.786;
   Gda140[124] = 2.0;
   Gda144[124] = Gscrab160;
   Gda132[125] = 0.886;
   Gda136[125] = 0.786;
   Gda140[125] = 2.24;
   Gda144[125] = Gscrab160;
   Gda132[126] = 0.886;
   Gda136[126] = 0.886;
   Gda140[126] = 1.618;
   Gda144[126] = Gscrab160;
   Gda132[127] = 0.886;
   Gda136[127] = 0.886;
   Gda140[127] = 2.0;
   Gda144[127] = Gscrab160;
   Gda132[128] = 0.618;
   Gda136[128] = 0.382;
   Gda140[128] = 1.27;
   Gda144[128] = Gsgartley168;
   Gda132[129] = 0.618;
   Gda136[129] = 0.382;
   Gda140[129] = 1.414;
   Gda144[129] = Gsgartley168;
   Gda132[130] = 0.618;
   Gda136[130] = 0.382;
   Gda140[130] = 1.618;
   Gda144[130] = Gsgartley168;
   Gda132[131] = 0.618;
   Gda136[131] = 0.447;
   Gda140[131] = 1.27;
   Gda144[131] = Gsgartley168;
   Gda132[132] = 0.618;
   Gda136[132] = 0.447;
   Gda140[132] = 1.414;
   Gda144[132] = Gsgartley168;
   Gda132[133] = 0.618;
   Gda136[133] = 0.447;
   Gda140[133] = 1.618;
   Gda144[133] = Gsgartley168;
   Gda132[134] = 0.618;
   Gda136[134] = 0.5;
   Gda140[134] = 1.27;
   Gda144[134] = Gsgartley168;
   Gda132[135] = 0.618;
   Gda136[135] = 0.5;
   Gda140[135] = 1.414;
   Gda144[135] = Gsgartley168;
   Gda132[136] = 0.618;
   Gda136[136] = 0.5;
   Gda140[136] = 1.618;
   Gda144[136] = Gsgartley168;
   Gda132[137] = 0.618;
   Gda136[137] = 0.618;
   Gda140[137] = 1.27;
   Gda144[137] = Gsgartley168;
   Gda132[138] = 0.618;
   Gda136[138] = 0.618;
   Gda140[138] = 1.414;
   Gda144[138] = Gsgartley168;
   Gda132[139] = 0.618;
   Gda136[139] = 0.618;
   Gda140[139] = 1.618;
   Gda144[139] = Gsgartley168;
   Gda132[140] = 0.618;
   Gda136[140] = 0.707;
   Gda140[140] = 1.27;
   Gda144[140] = Gsgartley168;
   Gda132[141] = 0.618;
   Gda136[141] = 0.707;
   Gda140[141] = 1.414;
   Gda144[141] = Gsgartley168;
   Gda132[142] = 0.618;
   Gda136[142] = 0.707;
   Gda140[142] = 1.618;
   Gda144[142] = Gsgartley168;
   Gda132[143] = 0.618;
   Gda136[143] = 0.786;
   Gda140[143] = 1.27;
   Gda144[143] = Gsgartley168;
   Gda132[144] = 0.618;
   Gda136[144] = 0.786;
   Gda140[144] = 1.414;
   Gda144[144] = Gsgartley168;
   Gda132[145] = 0.618;
   Gda136[145] = 0.786;
   Gda140[145] = 1.618;
   Gda144[145] = Gsgartley168;
   Gda132[146] = 0.618;
   Gda136[146] = 0.886;
   Gda140[146] = 1.27;
   Gda144[146] = Gsgartley168;
   Gda132[147] = 0.618;
   Gda136[147] = 0.886;
   Gda140[147] = 1.414;
   Gda144[147] = Gsgartley168;
   Gda132[148] = 0.618;
   Gda136[148] = 0.886;
   Gda140[148] = 1.618;
   Gda144[148] = Gsgartley168;
   Gda132[149] = 0.786;
   Gda136[149] = 0.382;
   Gda140[149] = 1.618;
   Gda144[149] = Gs176;
   Gda132[150] = 0.786;
   Gda136[150] = 0.382;
   Gda140[150] = 2.0;
   Gda144[150] = Gs176;
   Gda132[151] = 0.786;
   Gda136[151] = 0.382;
   Gda140[151] = 2.24;
   Gda144[151] = Gs176;
   Gda132[152] = 0.786;
   Gda136[152] = 0.447;
   Gda140[152] = 1.618;
   Gda144[152] = Gs176;
   Gda132[153] = 0.786;
   Gda136[153] = 0.447;
   Gda140[153] = 2.0;
   Gda144[153] = Gs176;
   Gda132[154] = 0.786;
   Gda136[154] = 0.447;
   Gda140[154] = 2.24;
   Gda144[154] = Gs176;
   Gda132[155] = 0.786;
   Gda136[155] = 0.5;
   Gda140[155] = 1.618;
   Gda144[155] = Gs176;
   Gda132[156] = 0.786;
   Gda136[156] = 0.5;
   Gda140[156] = 2.0;
   Gda144[156] = Gs176;
   Gda132[157] = 0.786;
   Gda136[157] = 0.5;
   Gda140[157] = 2.24;
   Gda144[157] = Gs176;
   Gda132[158] = 0.786;
   Gda136[158] = 0.618;
   Gda140[158] = 1.618;
   Gda144[158] = Gs176;
   Gda132[159] = 0.786;
   Gda136[159] = 0.618;
   Gda140[159] = 2.0;
   Gda144[159] = Gs176;
   Gda132[160] = 0.786;
   Gda136[160] = 0.618;
   Gda140[160] = 2.24;
   Gda144[160] = Gs176;
   Gda132[161] = 0.786;
   Gda136[161] = 0.707;
   Gda140[161] = 1.618;
   Gda144[161] = Gs176;
   Gda132[162] = 0.786;
   Gda136[162] = 0.707;
   Gda140[162] = 2.0;
   Gda144[162] = Gs176;
   Gda132[163] = 0.786;
   Gda136[163] = 0.707;
   Gda140[163] = 2.24;
   Gda144[163] = Gs176;
   Gda132[164] = 0.786;
   Gda136[164] = 0.786;
   Gda140[164] = 1.618;
   Gda144[164] = Gs176;
   Gda132[165] = 0.786;
   Gda136[165] = 0.786;
   Gda140[165] = 2.0;
   Gda144[165] = Gs176;
   Gda132[166] = 0.786;
   Gda136[166] = 0.786;
   Gda140[166] = 2.24;
   Gda144[166] = Gs176;
   Gda132[167] = 0.786;
   Gda136[167] = 0.886;
   Gda140[167] = 1.618;
   Gda144[167] = Gs176;
   Gda132[168] = 0.786;
   Gda136[168] = 0.886;
   Gda140[168] = 2.0;
   Gda144[168] = Gs176;
   Gda132[169] = 0.786;
   Gda136[169] = 0.886;
   Gda140[169] = 2.24;
   Gda144[169] = Gs176;
}

int Check(double ad0, double ad8, double ad16) {
   bool liret24 = FALSE;
   int li28 = 999999;
   for (int lindex32 = 0; lindex32 < 170; lindex32++) {
      Gda148[lindex32] = 0;
      Gda148[lindex32] = MathSqrt(MathPow(ad0 - Gda132[lindex32], 2) + MathPow(ad8 - Gda136[lindex32], 2) + MathPow(ad16 - Gda140[lindex32], 2));
      if (Gda148[lindex32] < li28) {
         li28 = Gda148[lindex32];
         liret24 = lindex32;
      }
   }
   return (liret24);
}